<template>
  <div>
    <h2>Edit profile</h2>
    <el-row>
      <el-col :sm="{span: 14, offset: 5}" :md="{span: 12, offset: 6}" :lg="{span: 10, offset: 7}">
        <el-form ref="form_profile" :model="profile" status-icon label-position="top">
          <el-form-item label="First name" prop="firstName">
            <el-input v-model="profile.firstName"></el-input>
          </el-form-item>

          <el-form-item label="Last name" prop="lastName">
            <el-input v-model="profile.lastName"></el-input>
          </el-form-item>

          <el-form-item label="Birthdate" prop="birthdate">
            <el-date-picker type="date" v-model="profile.birthdate" style="width: 100%"></el-date-picker>
          </el-form-item>

          <el-form-item label="Gender" prop="gender">
            <el-select v-model="profile.gender" style="width: 100%">
              <el-option label="Male" value="male"></el-option>
              <el-option label="Female" value="female"></el-option>
            </el-select>
          </el-form-item>

          <el-form-item label="Country" prop="countryCode">
            <el-select v-model="profile.countryCode" style="width: 100%">
              <el-option label="Venezuela" value="VE"></el-option>
            </el-select>
          </el-form-item>

          <el-form-item>
            <el-button type="primary" @click="submitForm()">
              Save
            </el-button>
          </el-form-item>
        </el-form>
      </el-col>
    </el-row>
  </div>
</template>

<script>
import gql from 'graphql-tag'

export default {
  apollo: {
    profile: {
      query: gql`{ currentUser { profile { firstName lastName birthdate gender countryCode } } }`,
      update ({ currentUser: { profile } }) { return Object.assign({}, profile) }
    }
  },

  data() {
    return {
      profile: {
        firstName: '',
        lastName: '',
        birthdate: '',
        gender: '',
        countryCode: ''
      },
      errors: {
        first_name: '',
        last_name: '',
        birthdate: '',
        gender: '',
        country_code: ''
      }
    }
  },

  methods: {
    submitForm() {
      this.$apollo.mutate({
        mutation: gql`mutation ($profile: ProfileInput!) {
          updateProfile(profile: $profile) {
            success
            message
            errors { field message }
          }
        }`,
        variables: {
          profile: this.$refs['form_profile'].model
        },
        update: (store, { data: { updateProfile }}) => {
          if(updateProfile.success) {
            this.$message.success('Profile updated successfully')
            this.$apollo.queries.profile.refetch()
          }
          else {
            this.$message.error('Failed to update profile')
            updateProfile.errors.forEach(error => { this.$data.errors[error.field] = error.message })
          }
        }
      })
    }
  }
}
</script>
